package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.service.UserFeedbackService;
import com.gxwebsoft.shop.entity.UserFeedback;
import com.gxwebsoft.shop.param.UserFeedbackParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 意见反馈记录表控制器
 *
 * @author 科技小王子
 * @since 2023-07-16 22:24:55
 */
@Api(tags = "意见反馈记录表管理")
@RestController
@RequestMapping("/api/shop/user-feedback")
public class UserFeedbackController extends BaseController {
    @Resource
    private UserFeedbackService userFeedbackService;

    @PreAuthorize("hasAuthority('shop:userFeedback:list')")
    @OperationLog
    @ApiOperation("分页查询意见反馈记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<UserFeedback>> page(UserFeedbackParam param) {
        // 使用关联查询
        return success(userFeedbackService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('shop:userFeedback:list')")
    @OperationLog
    @ApiOperation("查询全部意见反馈记录表")
    @GetMapping()
    public ApiResult<List<UserFeedback>> list(UserFeedbackParam param) {
        // 使用关联查询
        return success(userFeedbackService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:userFeedback:list')")
    @OperationLog
    @ApiOperation("根据id查询意见反馈记录表")
    @GetMapping("/{id}")
    public ApiResult<UserFeedback> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(userFeedbackService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('shop:userFeedback:save')")
    @OperationLog
    @ApiOperation("添加意见反馈记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody UserFeedback userFeedback) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          userFeedback.setUserId(loginUser.getUserId());
        }
        if (userFeedbackService.save(userFeedback)) {
            return success("已收到您的宝贵意见");
        }
        return fail("提交失败");
    }

    @PreAuthorize("hasAuthority('shop:userFeedback:update')")
    @OperationLog
    @ApiOperation("修改意见反馈记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody UserFeedback userFeedback) {
        if (userFeedbackService.updateById(userFeedback)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:userFeedback:remove')")
    @OperationLog
    @ApiOperation("删除意见反馈记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (userFeedbackService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('shop:userFeedback:save')")
    @OperationLog
    @ApiOperation("批量添加意见反馈记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<UserFeedback> list) {
        if (userFeedbackService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('shop:userFeedback:update')")
    @OperationLog
    @ApiOperation("批量修改意见反馈记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<UserFeedback> batchParam) {
        if (batchParam.update(userFeedbackService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('shop:userFeedback:remove')")
    @OperationLog
    @ApiOperation("批量删除意见反馈记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (userFeedbackService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
